window.Gleam.initSearch([{"doc":"xmleam","title":"xmleam","content":"# xmleam\n\n[![Package Version](https://img.shields.io/hexpm/v/xmleam)](https://hex.pm/packages/xmleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/xmleam/)\n\n```sh\ngleam add xmleam\n```\n```gleam\nimport gleam/io\nimport gleam/result\nimport xmleam/xml_builder.{\n  Opt, block_tag, end, end_xml, new, option_block_tag, option_content_tag,\n  option_tag, tag,\n}\n\npub fn main() {\n  let document = {\n    xml_builder.new_document()\n    |&gt; option_block_tag(\n      &quot;rss&quot;,\n      [Opt(&quot;xmlns:itunes&quot;, &quot;http://www.itunes.com/dtds/podcast-1.0.dtd&quot;)],\n      {\n        new()\n        |&gt; block_tag(&quot;channel&quot;, {\n          new()\n          |&gt; tag(&quot;title&quot;, &quot;Example RSS Feed&quot;)\n          |&gt; tag(&quot;description&quot;, &quot;this is a teaching example for xmleam&quot;)\n          |&gt; end()\n        })\n        |&gt; block_tag(&quot;item&quot;, {\n          new()\n          |&gt; tag(&quot;title&quot;, &quot;Example Item&quot;)\n          |&gt; end()\n        })\n        |&gt; end()\n      },\n    )\n    |&gt; end_xml()\n  }\n\n  io.println(result.unwrap(document, &quot;ERROR&quot;))\n\n  let document = {\n    xml_builder.new_document()\n    |&gt; option_tag(&quot;link&quot;, [\n      Opt(&quot;href&quot;, &quot;https://example.com&quot;),\n      Opt(&quot;idk&quot;, &quot;N/A&quot;),\n    ])\n    |&gt; option_content_tag(&quot;hello&quot;, [Opt(&quot;world&quot;, &quot;Earth&quot;)], &quot;AAAAAAA&quot;)\n    |&gt; end_xml()\n  }\n\n  io.println(result.unwrap(document, &quot;ERROR&quot;))\n}\n\n\n//Result\n&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;\n&lt;rss xmlns:itunes=&quot;http://www.itunes.com/dtds/podcast-1.0.dtd&quot;&gt; \n&lt;channel&gt; \n&lt;title&gt; Example RSS Feed &lt;/title&gt; \n&lt;description&gt; this is a teaching example for xmleam &lt;/description&gt; \n&lt;/channel&gt; \n&lt;item&gt; \n&lt;title&gt; Example Item &lt;/title&gt; \n&lt;/item&gt; \n&lt;/rss&gt; \n\n&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;\n&lt;link href=&quot;https://example.com&quot; idk=&quot;N/A&quot; /&gt;\n&lt;hello world=&quot;Earth&quot;&gt; AAAAAAA &lt;/hello&gt; \n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/xmleam&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"xmleam/xml_builder","title":"BuilderError","content":"pub type BuilderError {\n  ContentsEmpty\n  LabelEmpty\n  OptionsEmpty\n  VersionEmpty\n  EncodingEmpty\n  TagPlacedBeforeNew\n  InnerEmpty\n  EmptyDocument\n  NOTAPPLICABLE\n}\n\nContentsEmpty\n\n\nLabelEmpty\n\n\nOptionsEmpty\n\n\nVersionEmpty\n\n\nEncodingEmpty\n\n\nTagPlacedBeforeNew\n\n\nInnerEmpty\n\n\nEmptyDocument\n\n\nNOTAPPLICABLE\n\n\nSynonyms:\nxmleam/xml_builder.BuilderError\nxmleam/xml_builder BuilderError","url":"xmleam/xml_builder.html#BuilderError"},{"doc":"xmleam/xml_builder","title":"Option","content":"pub type Option {\n  Opt(label: String, value: String)\n}\n\nOpt(label: String, value: String)\n\n\nSynonyms:\nxmleam/xml_builder.Option\nxmleam/xml_builder Option","url":"xmleam/xml_builder.html#Option"},{"doc":"xmleam/xml_builder","title":"XmlBuilder","content":"pub type XmlBuilder =\n  Result(string_builder.StringBuilder, BuilderError)\n\n\nSynonyms:\nxmleam/xml_builder.XmlBuilder\nxmleam/xml_builder XmlBuilder","url":"xmleam/xml_builder.html#XmlBuilder"},{"doc":"xmleam/xml_builder","title":"block_tag","content":"pub fn block_tag(\n  document: Result(StringBuilder, BuilderError),\n  label: String,\n  inner: Result(StringBuilder, BuilderError),\n) -&gt; Result(StringBuilder, BuilderError)\n this starts a block which is a tag with other tags inside of it\n ie. &lt;owner&gt;\n         &lt;email&gt;example@example.com&lt;/email&gt;\n     &lt;/owner&gt;\n \n Usage: |&gt;block_tag(&quot;owner&quot;, {\n     new()\n     |&gt; tag(&quot;email&quot;, &quot;example@example.com&quot;)\n })\nSynonyms:\nxmleam/xml_builder.block_tag\nxmleam/xml_builder block_tag","url":"xmleam/xml_builder.html#block_tag"},{"doc":"xmleam/xml_builder","title":"end","content":"pub fn end(\n  inner: Result(StringBuilder, BuilderError),\n) -&gt; Result(StringBuilder, BuilderError)\n\nSynonyms:\nxmleam/xml_builder.end\nxmleam/xml_builder end","url":"xmleam/xml_builder.html#end"},{"doc":"xmleam/xml_builder","title":"end_xml","content":"pub fn end_xml(\n  document: Result(StringBuilder, BuilderError),\n) -&gt; Result(String, BuilderError)\n this one ends the xml document\n takes in the Xml Document and outputs\n a Result(String, BuilderError)\nSynonyms:\nxmleam/xml_builder.end_xml\nxmleam/xml_builder end_xml","url":"xmleam/xml_builder.html#end_xml"},{"doc":"xmleam/xml_builder","title":"new","content":"pub fn new() -&gt; Result(StringBuilder, BuilderError)\n this function starts the blocks inside of tags\nSynonyms:\nxmleam/xml_builder.new\nxmleam/xml_builder new","url":"xmleam/xml_builder.html#new"},{"doc":"xmleam/xml_builder","title":"new_advanced_document","content":"pub fn new_advanced_document(\n  version: String,\n  encoding: String,\n) -&gt; Result(StringBuilder, BuilderError)\n this funcion starts the builder and \n allows you to put in your own version and encoding\nSynonyms:\nxmleam/xml_builder.new_advanced_document\nxmleam/xml_builder new_advanced_document","url":"xmleam/xml_builder.html#new_advanced_document"},{"doc":"xmleam/xml_builder","title":"new_document","content":"pub fn new_document() -&gt; Result(StringBuilder, BuilderError)\n this function starts the builder and \n this function assumes version 1.0 and encoding UTF-8 if you need specific verisons or encoding\n use new_advanced_document(version, encoding)\nSynonyms:\nxmleam/xml_builder.new_document\nxmleam/xml_builder new_document","url":"xmleam/xml_builder.html#new_document"},{"doc":"xmleam/xml_builder","title":"option_block_tag","content":"pub fn option_block_tag(\n  document: Result(StringBuilder, BuilderError),\n  label: String,\n  options: List(Option),\n  inner: Result(StringBuilder, BuilderError),\n) -&gt; Result(StringBuilder, BuilderError)\n This is a block tag that has options\nSynonyms:\nxmleam/xml_builder.option_block_tag\nxmleam/xml_builder option_block_tag","url":"xmleam/xml_builder.html#option_block_tag"},{"doc":"xmleam/xml_builder","title":"option_content_tag","content":"pub fn option_content_tag(\n  document: Result(StringBuilder, BuilderError),\n  label: String,\n  options: List(Option),\n  contents: String,\n) -&gt; Result(StringBuilder, BuilderError)\n This is for a tag with options and content\n ie. &lt;hello world=&quot;hi&quot;&gt; ?? &lt;hello&gt; \nSynonyms:\nxmleam/xml_builder.option_content_tag\nxmleam/xml_builder option_content_tag","url":"xmleam/xml_builder.html#option_content_tag"},{"doc":"xmleam/xml_builder","title":"option_tag","content":"pub fn option_tag(\n  document: Result(StringBuilder, BuilderError),\n  label: String,\n  options: List(Option),\n) -&gt; Result(StringBuilder, BuilderError)\nThis is a tag with options that self-closes \n ie. &lt;link href=&quot;https://example.com&quot; /&gt;\nSynonyms:\nxmleam/xml_builder.option_tag\nxmleam/xml_builder option_tag","url":"xmleam/xml_builder.html#option_tag"},{"doc":"xmleam/xml_builder","title":"tag","content":"pub fn tag(\n  document: Result(StringBuilder, BuilderError),\n  label: String,\n  contents: String,\n) -&gt; Result(StringBuilder, BuilderError)\n this is a basic tag that takes in a label and contents and a \n document in the form of an XmlBuilder\n this is intended to be used in a pipe chain\n ie. new_document() \n     |&gt; tag(&quot;hello&quot;, &quot;world&quot;)\n Throws an error if anything is left blank\nSynonyms:\nxmleam/xml_builder.tag\nxmleam/xml_builder tag","url":"xmleam/xml_builder.html#tag"},{"doc":"xmleam/xml_builder","title":"xmleam/xml_builder","content":"Goals for this module:\n 1. make xml like the string_builder\n    ie. xml_builder.new()\n        |&gt; xml_builder.block_tag(&quot;name&quot;, {\n            xml_builder.new()\n            |&gt; xml_builder.tag(&quot;hello&quot;, &quot;world&quot;)\n            |&gt; xml_builder.tag(&quot;maybe&quot;, &quot;here&quot;)})\n        |&gt; xml_builder.option_tag(&quot;link&quot;, Opt.(&quot;href&quot;, &quot;https://example.com&quot;))\n To:\n &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; xml?&gt;\n &lt;name&gt;\n    &lt;hello&gt; world &lt;/hello&gt;\n &lt;/name&gt;","url":"xmleam/xml_builder.html"},{"doc":"xmleam","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nxmleam.main\nxmleam main","url":"xmleam.html#main"},{"doc":"xmleam","title":"xmleam","content":"","url":"xmleam.html"},{"doc":"xmleam/builder","title":"Option","content":"pub type Option {\n  Opt(label: String, value: String)\n}\n\nOpt(label: String, value: String)\n\n\nSynonyms:\nxmleam/builder.Option\nxmleam/builder Option","url":"xmleam/builder.html#Option"},{"doc":"xmleam/builder","title":"XmlError","content":"pub type XmlError {\n  ContentsEmpty\n  TagNameEmpty\n  OptionsEmpty\n  VersionEmpty\n  EncodingEmpty\n}\n\nContentsEmpty\n\n\nTagNameEmpty\n\n\nOptionsEmpty\n\n\nVersionEmpty\n\n\nEncodingEmpty\n\n\nSynonyms:\nxmleam/builder.XmlError\nxmleam/builder XmlError","url":"xmleam/builder.html#XmlError"},{"doc":"xmleam/builder","title":"basic_tag","content":"pub fn basic_tag(\n  tag_name: String,\n  contents: List(String),\n) -&gt; Result(String, XmlError)\nThis is a basic tag, ie. name and the contents\n Ex. builder.basic_tag(&quot;pubDate&quot;, &quot;12 Mar 2024&quot;) to\n &lt;pubDate&gt; 12 Mar 2024 &lt;pubDate&gt; \\n\n basic_tag(tag_name, contents)\nSynonyms:\nxmleam/builder.basic_tag\nxmleam/builder basic_tag","url":"xmleam/builder.html#basic_tag"},{"doc":"xmleam/builder","title":"opts_cont_tag","content":"pub fn opts_cont_tag(\n  tag_name: String,\n  options: List(Option),\n  contents: List(String),\n) -&gt; Result(String, XmlError)\nThis is a tag with options and content\n Ex. opts_cont_tag(&quot;enclosure&quot;, [opts(&quot;url&quot;, &quot;https://example.com&quot;)], \n &quot;IDK why you would use this&quot;)\n -&gt; \n &lt;enclosure url=&quot;https://example.com&quot;&gt; IDK why you would use this &lt;/enclosure&gt;\nSynonyms:\nxmleam/builder.opts_cont_tag\nxmleam/builder opts_cont_tag","url":"xmleam/builder.html#opts_cont_tag"},{"doc":"xmleam/builder","title":"opts_tag","content":"pub fn opts_tag(\n  tag_name: String,\n  options: List(Option),\n) -&gt; Result(String, XmlError)\n\nSynonyms:\nxmleam/builder.opts_tag\nxmleam/builder opts_tag","url":"xmleam/builder.html#opts_tag"},{"doc":"xmleam/builder","title":"xml","content":"pub fn xml(\n  version: String,\n  encoding: String,\n  document_parts: List(String),\n) -&gt; Result(String, XmlError)\nThis is the header tag REQUIRED by all valid XML documents\n Usage: xml(version (1.0), encoding (UTF-8), \n document: List(String) -&gt; [basic_tag(...), basic_tag(...)])\nSynonyms:\nxmleam/builder.xml\nxmleam/builder xml","url":"xmleam/builder.html#xml"},{"doc":"xmleam/builder","title":"xmleam/builder","content":"","url":"xmleam/builder.html"}]);